import random
import numpy as np
import matplotlib.pyplot as plt
import classFunctions as cf

folder = r"HivesPositioningImages/"


def areaRandomColors():
  r = lambda: random.randint(0,255)
  c='#%02X%02X%02X' % (r(),r(),r())
  return c

COLOR = {
    True:  '#6699cc',
    False: '#ff3333'
    }

def v_color(ob):
    return COLOR[ob.is_valid]

def myColors(ar,d):
  color=255*(ar[d]-min(ar))/(max(ar)-min(ar))
  c='#%02X%02X%02X' % (abs(int(255-color)), abs(int(color)),0)
  return c

def legendaCoef(ar):
  legArray = []
  a = set(ar)
  legArray = list(a)
  legArray.sort()
  return legArray

def plot_line(ax, ob, color='#999999', zorder=1, linewidth=3, alpha=1):
    x, y = ob.xy
    ax.plot(x, y, color=color, linewidth=linewidth, solid_capstyle='round', zorder=zorder, alpha=alpha)


def StepDetails(subPlotTitle, arStart, MaxValueInBar, arCoef, arFinish, xar, yar, hc, i, num):
    folder = r"HivesPositioningImages/PositioningStepsImages/"
    fig = plt.figure(figsize=(30, 30))
    fig.subplots_adjust(hspace=0.5, wspace=0.4)

    plt.subplot(1, 3, 1).set(title=subPlotTitle)
    plt.imshow(arStart, vmax=MaxValueInBar, vmin=0)
    plt.colorbar(fraction=0.046, pad=0.04)

    plt.subplot(1, 3, 2)
    plt.imshow(arCoef)
    plt.colorbar(fraction=0.046, pad=0.04)

    plt.subplot(1, 3, 3)
    plt.imshow(arFinish, vmax=MaxValueInBar, vmin=0)
    plt.colorbar(fraction=0.046, pad=0.04)

    for k in range(0, len(xar)):

        plt.scatter(yar[k], xar[k], c='red', s=15, alpha=1)
        plt.text(yar[k] + 1, xar[k] + 1, str(hc[k]), fontsize=12, color='cyan')

    t = str(num) + " - (Step - " + str(i)+").png"
    plt.savefig(folder + t)
    plt.close()


def imageWithPoints(xar, yar, r, t, col="red"):

    plt.figure(figsize=(15, 15))
    MapImage = plt.imread('map_1000_1000.png')
    plt.imshow(MapImage)
    plt.yticks(np.arange(0, 1000, step=100))
    plt.xticks(np.arange(0, 1000, step=100))
    plt.scatter(xar, yar, c='white', s=np.pi*r**2, alpha=0.4)
    plt.scatter(xar, yar, c=col, s=50, alpha=1)
    te = "(" + str(xar) + "," + str(yar) + ")"
    plt.text(xar-55, yar + 35, te, fontsize=18, color='black')

    plt.title(t, fontsize="15")
    plt.savefig(cf.folder + t+".png")
    plt.close()

def imageWithPoints2(xar, yar, r, t, col="red"):

    plt.figure(figsize=(15, 15))
    MapImage = plt.imread('map_1000_1000.png')
    plt.imshow(MapImage)
    plt.yticks(np.arange(0, 1000, step=100))
    plt.xticks(np.arange(0, 1000, step=100))

    rad = r+250
    plt.scatter(xar, yar, facecolors='none', s=np.pi*rad**2, linewidths=500, edgecolors="white", alpha=1)
    plt.scatter(xar, yar, c=col, s=50, alpha=1)
    te = "(" + str(xar) + "," + str(yar) + ")"
    plt.text(xar-60, yar + 35, te, fontsize=18, color='cyan')

    plt.title(t, fontsize="15")
    plt.savefig(cf.folder + t+".png")
    plt.close()