import parameters as p
import classFunctions as CF
import sys
import additionalFunctions as af


# ****************************************************
def main():
    if len(sys.argv) > 1:
        x = int(sys.argv[1].format())
        y = int(sys.argv[2].format())
    else:
        x = 500
        y = 500


    allFields = CF.FieldsList(p.polygonArray, p.coeficientArray, p.coeficientPesticidesArray)
    allFields.polygonsList[0].save_to_image("One single field")

    allFields.save_to_image("Level 0 - Fields without coefficients")
    allFields.save_to_image("Level 1 - Fields with coefficients","coefficient")
    allFields.save_to_image("Level 2 - Fields with pesticides","pesticides")

    # if shape is circle
    circlePolygon = CF.Shape(p.polygonShape(p.yShapeCenter, p.xShapeCenter, p.polCir, x, y), x, y)
    circlePolygon.save_to_image("Level 3 - Shape with 'center' point")

    # -------------------------------------------------------
    ## ----- if shape is oval
    # ovalCenterX = x+100
    # ovalCenterY = y
    # circlePolygon = CF.Shape(p.polygonShapeOval(p.yShapeCenter, p.xShapeCenter, p.polCir, ovalCenterX, ovalCenterY, 1, 0.5), x, y)
    # circlePolygon.save_to_image("Level 31 - Shape (oval) with 'center' point")
    #----------------------------------------------------------------------------

    roadsList = CF.RoadsList(p.roadsArray, p.coeficientRoads)
    roadsList.save_to_image("Level 4 - Roads without coefficients")

    roadsList.save_to_image("Level 5 - Roads with width", "coefficient")

    roadsInShape = roadsList.intersection_with_shape(circlePolygon)
    roadsInShape.save_to_image("Level 5-1 - Roads intersection (with width)", "coefficient")

    onRoad = CF.pointOnRoad(x, y, roadsInShape)

    roadBigPolygons = CF.PolygonsBetweenRoadsList(roadsList, "Big")
    roadBigPolygons.save_to_image("Level 6 - Polygons between Big Roads")

    roadSmallPolygons = CF.PolygonsBetweenRoadsList(roadsList, "Small")
    roadSmallPolygons.save_to_image("Level 7 - Polygons between ALL Roads")

    roadBigPolygons.SetActivePolygonCoef(x, y)
    roadBigPolygons.save_to_image("Level 8 - Active polygon between big roads", show_active=True)

    roadSmallPolygons.SetActivePolygonCoef(x, y)
    roadSmallPolygons.save_to_image("Level 9 - Active polygon between all roads", show_active=True)

    inter = allFields.intersection_with_shape(circlePolygon)
    inter.save_to_image("Level 10 - Fields Intersection with Shape")
    inter.save_to_image("Level 10-1 - Fields (with coefficients) Intersection with Shape", "coefficient")
    inter.save_to_image("Level 10-2 - Fields (with pesticides) Intersection with Shape", "pesticides")

    inter1 = allFields.polygonsList[20].intersection_with_shape(circlePolygon)
    inter1.save_to_image("Level 11 - One Field Intersection with Shape")

    inter2 = roadBigPolygons.polygonsList[3].intersection_with_shape(circlePolygon)
    inter2.save_to_image("Level 12 - One Big Polygon Intersection with Shape")

    inter3 = roadSmallPolygons.polygonsList[15].intersection_with_shape(circlePolygon)
    inter3.save_to_image("Level 13 - One Small Polygon Intersection with Shape")

    inter41 = CF.RoadsPolygonList(roadSmallPolygons.polygonsList)
    inter4 = inter41.intersection_with_shape(circlePolygon)
    inter4.save_to_image("Level 14 - All Small Polygon Intersection with Shape")
    inter4.save_to_image("Level 14-1 - Active Small Polygon Intersection with Shape","Small")

    inter51 = CF.RoadsPolygonList(roadBigPolygons.polygonsList)
    inter5 = inter51.intersection_with_shape(circlePolygon)
    inter5.save_to_image("Level 15 - All Big Polygon Intersection with Shape")
    inter5.save_to_image("Level 15-1 - Active Big Polygon Intersection with Shape", "Big")

    inter6 = CF.intersection_between_intersection_polygons(inter5, inter4)
    inter6.save_to_image("Level 16 - Big Polygons Intersection with Small Polygons")

    inter7 = CF.intersection_between_fields_and_road_sum_polygons_intersection_results(inter, inter6)
    inter7.save_to_image("Level 17 - Fields Intersection with Polygons")

    inter8 = CF.intersection_between_fields_and_roads(inter7, roadsInShape)
    inter8.save_to_image("Level 18 - Near roads areas")

    honeySumWithRoadsAndPesticidesAndNearRoads = 0
    for i in range (len(inter8.polygonsList)):
        honeySumWithRoadsAndPesticidesAndNearRoads = honeySumWithRoadsAndPesticidesAndNearRoads + inter8.polygonsList[i].getHoneyWithAllRoadsCoefAndPesticidesAndNearRoads()
        assert isinstance(inter8.polygonsList, object)

    # ---------------------------------------------------------------------------------------------------------------------------------
    honeySum = 0   # honey with pesticides
    honeySumWithoutPesticides = 0
    honeySumWithRoads = 0
    honeySumWithRoadsAndPesticides = 0

    for i in range (len(inter7.polygonsList)):
        honeySum = honeySum + inter7.polygonsList[i].getHoneyWithPesticides()
        honeySumWithoutPesticides = honeySumWithoutPesticides + inter7.polygonsList[i].getHoney()
        honeySumWithRoads = honeySumWithRoads + inter7.polygonsList[i].getHoneyWithAllRoadsCoef()
        honeySumWithRoadsAndPesticides = honeySumWithRoadsAndPesticides + inter7.polygonsList[i].getHoneyWithAllRoadsCoefAndPesticides()

        assert isinstance(inter7.polygonsList, object)

    print("---------------------------------------------------------------------------------------------------")
    print("Coordinates =", x, y)
    print("---------------------------------------------------------------------------------------------------")
    print("The amount of honey, taking into account the delta, coefficients of fields WITHOUT pesticides =", round(honeySumWithoutPesticides,2))
    print("The amount of honey, taking into account the delta, coefficients of fields and pesticides =", round(honeySum,2))
    print("The amount of honey, taking into account the delta, coefficients of fields and roads =", round(honeySumWithRoads, 2))
    print("The amount of honey, taking into account the delta, coefficients of fields and roads and pesticides =", round(honeySumWithRoadsAndPesticides, 2))
    print("The LOSSES amount of honey, taking into account areas near roads =", round(honeySumWithRoadsAndPesticidesAndNearRoads, 2))

    final_honey = round(honeySumWithRoadsAndPesticides-honeySumWithRoadsAndPesticidesAndNearRoads, 2)
    print("The FINAL amount of honey, taking into account all parameters =", final_honey)

    hives_count = int(final_honey / (p.oneHiveKg + p.oneHiveHoneyKg))

    print("How many hives we can set =", hives_count)

    af.imageWithPoints(x, y, p.radius, "Map with point")
    af.imageWithPoints2(x, y, p.radius, "Map with point-2")

    # CF.write_json_screen(x, y, onRoad, final_honey, hives_count)

    #  ---- write in the file
    CF.write_json(CF.gen_record(x, y, onRoad, final_honey, hives_count))

if __name__ == "__main__":
    main()


